<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProductShortStayPrice ArrayType
 * @subpackage Arrays
 */
class ArrayOfProductShortStayPrice extends AbstractStructArrayBase
{
    /**
     * The productShortStayPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProductShortStayPrice[]
     */
    public $productShortStayPrice;
    /**
     * Constructor method for ArrayOfProductShortStayPrice
     * @uses ArrayOfProductShortStayPrice::setProductShortStayPrice()
     * @param \StructType\ProductShortStayPrice[] $productShortStayPrice
     */
    public function __construct(array $productShortStayPrice = array())
    {
        $this
            ->setProductShortStayPrice($productShortStayPrice);
    }
    /**
     * Get productShortStayPrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProductShortStayPrice[]|null
     */
    public function getProductShortStayPrice()
    {
        return isset($this->productShortStayPrice) ? $this->productShortStayPrice : null;
    }
    /**
     * This method is responsible for validating the values passed to the setProductShortStayPrice method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProductShortStayPrice method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProductShortStayPriceForArrayConstraintsFromSetProductShortStayPrice(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfProductShortStayPriceProductShortStayPriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfProductShortStayPriceProductShortStayPriceItem instanceof \StructType\ProductShortStayPrice) {
                $invalidValues[] = is_object($arrayOfProductShortStayPriceProductShortStayPriceItem) ? get_class($arrayOfProductShortStayPriceProductShortStayPriceItem) : sprintf('%s(%s)', gettype($arrayOfProductShortStayPriceProductShortStayPriceItem), var_export($arrayOfProductShortStayPriceProductShortStayPriceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The productShortStayPrice property can only contain items of type \StructType\ProductShortStayPrice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set productShortStayPrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProductShortStayPrice[] $productShortStayPrice
     * @return \ArrayType\ArrayOfProductShortStayPrice
     */
    public function setProductShortStayPrice(array $productShortStayPrice = array())
    {
        // validation for constraint: array
        if ('' !== ($productShortStayPriceArrayErrorMessage = self::validateProductShortStayPriceForArrayConstraintsFromSetProductShortStayPrice($productShortStayPrice))) {
            throw new \InvalidArgumentException($productShortStayPriceArrayErrorMessage, __LINE__);
        }
        if (is_null($productShortStayPrice) || (is_array($productShortStayPrice) && empty($productShortStayPrice))) {
            unset($this->productShortStayPrice);
        } else {
            $this->productShortStayPrice = $productShortStayPrice;
        }
        return $this;
    }
    /**
     * Add item to productShortStayPrice value
     * @throws \InvalidArgumentException
     * @param \StructType\ProductShortStayPrice $item
     * @return \ArrayType\ArrayOfProductShortStayPrice
     */
    public function addToProductShortStayPrice(\StructType\ProductShortStayPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProductShortStayPrice) {
            throw new \InvalidArgumentException(sprintf('The productShortStayPrice property can only contain items of type \StructType\ProductShortStayPrice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->productShortStayPrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProductShortStayPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProductShortStayPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProductShortStayPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProductShortStayPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProductShortStayPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string productShortStayPrice
     */
    public function getAttributeName()
    {
        return 'productShortStayPrice';
    }
}
