<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CanauxAffectation StructType
 * @subpackage Structs
 */
class CanauxAffectation extends AbstractStructBase
{
    /**
     * The PackIndiv
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $PackIndiv;
    /**
     * The EngineIDList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt_1
     */
    public $EngineIDList;
    /**
     * The TypeHebergementList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTypeHebergement
     */
    public $TypeHebergementList;
    /**
     * The GrilleModelKeyList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $GrilleModelKeyList;
    /**
     * The CodePackList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $CodePackList;
    /**
     * The CodeIsoLandEstablishmentList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $CodeIsoLandEstablishmentList;
    /**
     * The NotCumulableSurOffreIdList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt_1
     */
    public $NotCumulableSurOffreIdList;
    /**
     * Constructor method for CanauxAffectation
     * @uses CanauxAffectation::setPackIndiv()
     * @uses CanauxAffectation::setEngineIDList()
     * @uses CanauxAffectation::setTypeHebergementList()
     * @uses CanauxAffectation::setGrilleModelKeyList()
     * @uses CanauxAffectation::setCodePackList()
     * @uses CanauxAffectation::setCodeIsoLandEstablishmentList()
     * @uses CanauxAffectation::setNotCumulableSurOffreIdList()
     * @param bool $packIndiv
     * @param \ArrayType\ArrayOfInt_1 $engineIDList
     * @param \ArrayType\ArrayOfTypeHebergement $typeHebergementList
     * @param \ArrayType\ArrayOfString $grilleModelKeyList
     * @param \ArrayType\ArrayOfString $codePackList
     * @param \ArrayType\ArrayOfString $codeIsoLandEstablishmentList
     * @param \ArrayType\ArrayOfInt_1 $notCumulableSurOffreIdList
     */
    public function __construct($packIndiv = null, \ArrayType\ArrayOfInt_1 $engineIDList = null, \ArrayType\ArrayOfTypeHebergement $typeHebergementList = null, \ArrayType\ArrayOfString $grilleModelKeyList = null, \ArrayType\ArrayOfString $codePackList = null, \ArrayType\ArrayOfString $codeIsoLandEstablishmentList = null, \ArrayType\ArrayOfInt_1 $notCumulableSurOffreIdList = null)
    {
        $this
            ->setPackIndiv($packIndiv)
            ->setEngineIDList($engineIDList)
            ->setTypeHebergementList($typeHebergementList)
            ->setGrilleModelKeyList($grilleModelKeyList)
            ->setCodePackList($codePackList)
            ->setCodeIsoLandEstablishmentList($codeIsoLandEstablishmentList)
            ->setNotCumulableSurOffreIdList($notCumulableSurOffreIdList);
    }
    /**
     * Get PackIndiv value
     * @return bool
     */
    public function getPackIndiv()
    {
        return $this->PackIndiv;
    }
    /**
     * Set PackIndiv value
     * @param bool $packIndiv
     * @return \StructType\CanauxAffectation
     */
    public function setPackIndiv($packIndiv = null)
    {
        // validation for constraint: boolean
        if (!is_null($packIndiv) && !is_bool($packIndiv)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($packIndiv, true), gettype($packIndiv)), __LINE__);
        }
        $this->PackIndiv = $packIndiv;
        return $this;
    }
    /**
     * Get EngineIDList value
     * @return \ArrayType\ArrayOfInt_1|null
     */
    public function getEngineIDList()
    {
        return $this->EngineIDList;
    }
    /**
     * Set EngineIDList value
     * @param \ArrayType\ArrayOfInt_1 $engineIDList
     * @return \StructType\CanauxAffectation
     */
    public function setEngineIDList(\ArrayType\ArrayOfInt_1 $engineIDList = null)
    {
        $this->EngineIDList = $engineIDList;
        return $this;
    }
    /**
     * Get TypeHebergementList value
     * @return \ArrayType\ArrayOfTypeHebergement|null
     */
    public function getTypeHebergementList()
    {
        return $this->TypeHebergementList;
    }
    /**
     * Set TypeHebergementList value
     * @param \ArrayType\ArrayOfTypeHebergement $typeHebergementList
     * @return \StructType\CanauxAffectation
     */
    public function setTypeHebergementList(\ArrayType\ArrayOfTypeHebergement $typeHebergementList = null)
    {
        $this->TypeHebergementList = $typeHebergementList;
        return $this;
    }
    /**
     * Get GrilleModelKeyList value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getGrilleModelKeyList()
    {
        return $this->GrilleModelKeyList;
    }
    /**
     * Set GrilleModelKeyList value
     * @param \ArrayType\ArrayOfString $grilleModelKeyList
     * @return \StructType\CanauxAffectation
     */
    public function setGrilleModelKeyList(\ArrayType\ArrayOfString $grilleModelKeyList = null)
    {
        $this->GrilleModelKeyList = $grilleModelKeyList;
        return $this;
    }
    /**
     * Get CodePackList value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getCodePackList()
    {
        return $this->CodePackList;
    }
    /**
     * Set CodePackList value
     * @param \ArrayType\ArrayOfString $codePackList
     * @return \StructType\CanauxAffectation
     */
    public function setCodePackList(\ArrayType\ArrayOfString $codePackList = null)
    {
        $this->CodePackList = $codePackList;
        return $this;
    }
    /**
     * Get CodeIsoLandEstablishmentList value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getCodeIsoLandEstablishmentList()
    {
        return $this->CodeIsoLandEstablishmentList;
    }
    /**
     * Set CodeIsoLandEstablishmentList value
     * @param \ArrayType\ArrayOfString $codeIsoLandEstablishmentList
     * @return \StructType\CanauxAffectation
     */
    public function setCodeIsoLandEstablishmentList(\ArrayType\ArrayOfString $codeIsoLandEstablishmentList = null)
    {
        $this->CodeIsoLandEstablishmentList = $codeIsoLandEstablishmentList;
        return $this;
    }
    /**
     * Get NotCumulableSurOffreIdList value
     * @return \ArrayType\ArrayOfInt_1|null
     */
    public function getNotCumulableSurOffreIdList()
    {
        return $this->NotCumulableSurOffreIdList;
    }
    /**
     * Set NotCumulableSurOffreIdList value
     * @param \ArrayType\ArrayOfInt_1 $notCumulableSurOffreIdList
     * @return \StructType\CanauxAffectation
     */
    public function setNotCumulableSurOffreIdList(\ArrayType\ArrayOfInt_1 $notCumulableSurOffreIdList = null)
    {
        $this->NotCumulableSurOffreIdList = $notCumulableSurOffreIdList;
        return $this;
    }
}
