<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FilterOffreInjectee StructType
 * @subpackage Structs
 */
class FilterOffreInjectee extends AbstractStructBase
{
    /**
     * The EnumReponseEstablishment
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $EnumReponseEstablishment;
    /**
     * The IsCachee
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IsCachee;
    /**
     * The OnlyDateLimiteAcceptationInTheFuture
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $OnlyDateLimiteAcceptationInTheFuture;
    /**
     * The OnlyExecutedCampaign
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $OnlyExecutedCampaign;
    /**
     * The GeneralOSIDList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt_1
     */
    public $GeneralOSIDList;
    /**
     * The UserMonitoringIDList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt_1
     */
    public $UserMonitoringIDList;
    /**
     * The TypeOSList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTypeOS
     */
    public $TypeOSList;
    /**
     * The EstablishmentIDList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt_1
     */
    public $EstablishmentIDList;
    /**
     * The MyCanauxAffectation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CanauxAffectation
     */
    public $MyCanauxAffectation;
    /**
     * The DiscountCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DiscountCode;
    /**
     * Constructor method for FilterOffreInjectee
     * @uses FilterOffreInjectee::setEnumReponseEstablishment()
     * @uses FilterOffreInjectee::setIsCachee()
     * @uses FilterOffreInjectee::setOnlyDateLimiteAcceptationInTheFuture()
     * @uses FilterOffreInjectee::setOnlyExecutedCampaign()
     * @uses FilterOffreInjectee::setGeneralOSIDList()
     * @uses FilterOffreInjectee::setUserMonitoringIDList()
     * @uses FilterOffreInjectee::setTypeOSList()
     * @uses FilterOffreInjectee::setEstablishmentIDList()
     * @uses FilterOffreInjectee::setMyCanauxAffectation()
     * @uses FilterOffreInjectee::setDiscountCode()
     * @param string $enumReponseEstablishment
     * @param bool $isCachee
     * @param bool $onlyDateLimiteAcceptationInTheFuture
     * @param bool $onlyExecutedCampaign
     * @param \ArrayType\ArrayOfInt_1 $generalOSIDList
     * @param \ArrayType\ArrayOfInt_1 $userMonitoringIDList
     * @param \ArrayType\ArrayOfTypeOS $typeOSList
     * @param \ArrayType\ArrayOfInt_1 $establishmentIDList
     * @param \StructType\CanauxAffectation $myCanauxAffectation
     * @param string $discountCode
     */
    public function __construct($enumReponseEstablishment = null, $isCachee = null, $onlyDateLimiteAcceptationInTheFuture = null, $onlyExecutedCampaign = null, \ArrayType\ArrayOfInt_1 $generalOSIDList = null, \ArrayType\ArrayOfInt_1 $userMonitoringIDList = null, \ArrayType\ArrayOfTypeOS $typeOSList = null, \ArrayType\ArrayOfInt_1 $establishmentIDList = null, \StructType\CanauxAffectation $myCanauxAffectation = null, $discountCode = null)
    {
        $this
            ->setEnumReponseEstablishment($enumReponseEstablishment)
            ->setIsCachee($isCachee)
            ->setOnlyDateLimiteAcceptationInTheFuture($onlyDateLimiteAcceptationInTheFuture)
            ->setOnlyExecutedCampaign($onlyExecutedCampaign)
            ->setGeneralOSIDList($generalOSIDList)
            ->setUserMonitoringIDList($userMonitoringIDList)
            ->setTypeOSList($typeOSList)
            ->setEstablishmentIDList($establishmentIDList)
            ->setMyCanauxAffectation($myCanauxAffectation)
            ->setDiscountCode($discountCode);
    }
    /**
     * Get EnumReponseEstablishment value
     * @return string
     */
    public function getEnumReponseEstablishment()
    {
        return $this->EnumReponseEstablishment;
    }
    /**
     * Set EnumReponseEstablishment value
     * @uses \EnumType\EnumReponseEstablishment::valueIsValid()
     * @uses \EnumType\EnumReponseEstablishment::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $enumReponseEstablishment
     * @return \StructType\FilterOffreInjectee
     */
    public function setEnumReponseEstablishment($enumReponseEstablishment = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\EnumReponseEstablishment::valueIsValid($enumReponseEstablishment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\EnumReponseEstablishment', is_array($enumReponseEstablishment) ? implode(', ', $enumReponseEstablishment) : var_export($enumReponseEstablishment, true), implode(', ', \EnumType\EnumReponseEstablishment::getValidValues())), __LINE__);
        }
        $this->EnumReponseEstablishment = $enumReponseEstablishment;
        return $this;
    }
    /**
     * Get IsCachee value
     * @return bool
     */
    public function getIsCachee()
    {
        return $this->IsCachee;
    }
    /**
     * Set IsCachee value
     * @param bool $isCachee
     * @return \StructType\FilterOffreInjectee
     */
    public function setIsCachee($isCachee = null)
    {
        // validation for constraint: boolean
        if (!is_null($isCachee) && !is_bool($isCachee)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isCachee, true), gettype($isCachee)), __LINE__);
        }
        $this->IsCachee = $isCachee;
        return $this;
    }
    /**
     * Get OnlyDateLimiteAcceptationInTheFuture value
     * @return bool
     */
    public function getOnlyDateLimiteAcceptationInTheFuture()
    {
        return $this->OnlyDateLimiteAcceptationInTheFuture;
    }
    /**
     * Set OnlyDateLimiteAcceptationInTheFuture value
     * @param bool $onlyDateLimiteAcceptationInTheFuture
     * @return \StructType\FilterOffreInjectee
     */
    public function setOnlyDateLimiteAcceptationInTheFuture($onlyDateLimiteAcceptationInTheFuture = null)
    {
        // validation for constraint: boolean
        if (!is_null($onlyDateLimiteAcceptationInTheFuture) && !is_bool($onlyDateLimiteAcceptationInTheFuture)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($onlyDateLimiteAcceptationInTheFuture, true), gettype($onlyDateLimiteAcceptationInTheFuture)), __LINE__);
        }
        $this->OnlyDateLimiteAcceptationInTheFuture = $onlyDateLimiteAcceptationInTheFuture;
        return $this;
    }
    /**
     * Get OnlyExecutedCampaign value
     * @return bool
     */
    public function getOnlyExecutedCampaign()
    {
        return $this->OnlyExecutedCampaign;
    }
    /**
     * Set OnlyExecutedCampaign value
     * @param bool $onlyExecutedCampaign
     * @return \StructType\FilterOffreInjectee
     */
    public function setOnlyExecutedCampaign($onlyExecutedCampaign = null)
    {
        // validation for constraint: boolean
        if (!is_null($onlyExecutedCampaign) && !is_bool($onlyExecutedCampaign)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($onlyExecutedCampaign, true), gettype($onlyExecutedCampaign)), __LINE__);
        }
        $this->OnlyExecutedCampaign = $onlyExecutedCampaign;
        return $this;
    }
    /**
     * Get GeneralOSIDList value
     * @return \ArrayType\ArrayOfInt_1|null
     */
    public function getGeneralOSIDList()
    {
        return $this->GeneralOSIDList;
    }
    /**
     * Set GeneralOSIDList value
     * @param \ArrayType\ArrayOfInt_1 $generalOSIDList
     * @return \StructType\FilterOffreInjectee
     */
    public function setGeneralOSIDList(\ArrayType\ArrayOfInt_1 $generalOSIDList = null)
    {
        $this->GeneralOSIDList = $generalOSIDList;
        return $this;
    }
    /**
     * Get UserMonitoringIDList value
     * @return \ArrayType\ArrayOfInt_1|null
     */
    public function getUserMonitoringIDList()
    {
        return $this->UserMonitoringIDList;
    }
    /**
     * Set UserMonitoringIDList value
     * @param \ArrayType\ArrayOfInt_1 $userMonitoringIDList
     * @return \StructType\FilterOffreInjectee
     */
    public function setUserMonitoringIDList(\ArrayType\ArrayOfInt_1 $userMonitoringIDList = null)
    {
        $this->UserMonitoringIDList = $userMonitoringIDList;
        return $this;
    }
    /**
     * Get TypeOSList value
     * @return \ArrayType\ArrayOfTypeOS|null
     */
    public function getTypeOSList()
    {
        return $this->TypeOSList;
    }
    /**
     * Set TypeOSList value
     * @param \ArrayType\ArrayOfTypeOS $typeOSList
     * @return \StructType\FilterOffreInjectee
     */
    public function setTypeOSList(\ArrayType\ArrayOfTypeOS $typeOSList = null)
    {
        $this->TypeOSList = $typeOSList;
        return $this;
    }
    /**
     * Get EstablishmentIDList value
     * @return \ArrayType\ArrayOfInt_1|null
     */
    public function getEstablishmentIDList()
    {
        return $this->EstablishmentIDList;
    }
    /**
     * Set EstablishmentIDList value
     * @param \ArrayType\ArrayOfInt_1 $establishmentIDList
     * @return \StructType\FilterOffreInjectee
     */
    public function setEstablishmentIDList(\ArrayType\ArrayOfInt_1 $establishmentIDList = null)
    {
        $this->EstablishmentIDList = $establishmentIDList;
        return $this;
    }
    /**
     * Get MyCanauxAffectation value
     * @return \StructType\CanauxAffectation|null
     */
    public function getMyCanauxAffectation()
    {
        return $this->MyCanauxAffectation;
    }
    /**
     * Set MyCanauxAffectation value
     * @param \StructType\CanauxAffectation $myCanauxAffectation
     * @return \StructType\FilterOffreInjectee
     */
    public function setMyCanauxAffectation(\StructType\CanauxAffectation $myCanauxAffectation = null)
    {
        $this->MyCanauxAffectation = $myCanauxAffectation;
        return $this;
    }
    /**
     * Get DiscountCode value
     * @return string|null
     */
    public function getDiscountCode()
    {
        return $this->DiscountCode;
    }
    /**
     * Set DiscountCode value
     * @param string $discountCode
     * @return \StructType\FilterOffreInjectee
     */
    public function setDiscountCode($discountCode = null)
    {
        // validation for constraint: string
        if (!is_null($discountCode) && !is_string($discountCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($discountCode, true), gettype($discountCode)), __LINE__);
        }
        $this->DiscountCode = $discountCode;
        return $this;
    }
}
