<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeographicalFilter StructType
 * @subpackage Structs
 */
class GeographicalFilter extends AbstractStructBase
{
    /**
     * The gps
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Gps
     */
    public $gps;
    /**
     * The territorialList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTerritorial
     */
    public $territorialList;
    /**
     * The OsmTerritoriesIds
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfLong
     */
    public $OsmTerritoriesIds;
    /**
     * The GeoPolygonsIds
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt_1
     */
    public $GeoPolygonsIds;
    /**
     * The ufi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\UfiFilter
     */
    public $ufi;
    /**
     * Constructor method for GeographicalFilter
     * @uses GeographicalFilter::setGps()
     * @uses GeographicalFilter::setTerritorialList()
     * @uses GeographicalFilter::setOsmTerritoriesIds()
     * @uses GeographicalFilter::setGeoPolygonsIds()
     * @uses GeographicalFilter::setUfi()
     * @param \StructType\Gps $gps
     * @param \ArrayType\ArrayOfTerritorial $territorialList
     * @param \ArrayType\ArrayOfLong $osmTerritoriesIds
     * @param \ArrayType\ArrayOfInt_1 $geoPolygonsIds
     * @param \StructType\UfiFilter $ufi
     */
    public function __construct(\StructType\Gps $gps = null, \ArrayType\ArrayOfTerritorial $territorialList = null, \ArrayType\ArrayOfLong $osmTerritoriesIds = null, \ArrayType\ArrayOfInt_1 $geoPolygonsIds = null, \StructType\UfiFilter $ufi = null)
    {
        $this
            ->setGps($gps)
            ->setTerritorialList($territorialList)
            ->setOsmTerritoriesIds($osmTerritoriesIds)
            ->setGeoPolygonsIds($geoPolygonsIds)
            ->setUfi($ufi);
    }
    /**
     * Get gps value
     * @return \StructType\Gps|null
     */
    public function getGps()
    {
        return $this->gps;
    }
    /**
     * Set gps value
     * @param \StructType\Gps $gps
     * @return \StructType\GeographicalFilter
     */
    public function setGps(\StructType\Gps $gps = null)
    {
        $this->gps = $gps;
        return $this;
    }
    /**
     * Get territorialList value
     * @return \ArrayType\ArrayOfTerritorial|null
     */
    public function getTerritorialList()
    {
        return $this->territorialList;
    }
    /**
     * Set territorialList value
     * @param \ArrayType\ArrayOfTerritorial $territorialList
     * @return \StructType\GeographicalFilter
     */
    public function setTerritorialList(\ArrayType\ArrayOfTerritorial $territorialList = null)
    {
        $this->territorialList = $territorialList;
        return $this;
    }
    /**
     * Get OsmTerritoriesIds value
     * @return \ArrayType\ArrayOfLong|null
     */
    public function getOsmTerritoriesIds()
    {
        return $this->OsmTerritoriesIds;
    }
    /**
     * Set OsmTerritoriesIds value
     * @param \ArrayType\ArrayOfLong $osmTerritoriesIds
     * @return \StructType\GeographicalFilter
     */
    public function setOsmTerritoriesIds(\ArrayType\ArrayOfLong $osmTerritoriesIds = null)
    {
        $this->OsmTerritoriesIds = $osmTerritoriesIds;
        return $this;
    }
    /**
     * Get GeoPolygonsIds value
     * @return \ArrayType\ArrayOfInt_1|null
     */
    public function getGeoPolygonsIds()
    {
        return $this->GeoPolygonsIds;
    }
    /**
     * Set GeoPolygonsIds value
     * @param \ArrayType\ArrayOfInt_1 $geoPolygonsIds
     * @return \StructType\GeographicalFilter
     */
    public function setGeoPolygonsIds(\ArrayType\ArrayOfInt_1 $geoPolygonsIds = null)
    {
        $this->GeoPolygonsIds = $geoPolygonsIds;
        return $this;
    }
    /**
     * Get ufi value
     * @return \StructType\UfiFilter|null
     */
    public function getUfi()
    {
        return $this->ufi;
    }
    /**
     * Set ufi value
     * @param \StructType\UfiFilter $ufi
     * @return \StructType\GeographicalFilter
     */
    public function setUfi(\StructType\UfiFilter $ufi = null)
    {
        $this->ufi = $ufi;
        return $this;
    }
}
