<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResultInfo StructType
 * @subpackage Structs
 */
class ResultInfo extends AbstractStructBase
{
    /**
     * The allSummary
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $allSummary;
    /**
     * The infoCountry
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $infoCountry;
    /**
     * The infoAdministrativeZone1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $infoAdministrativeZone1;
    /**
     * The infoStars
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $infoStars;
    /**
     * The infoServices
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $infoServices;
    /**
     * The infoSubTypeProduct
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $infoSubTypeProduct;
    /**
     * The argumentForKml
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $argumentForKml;
    /**
     * The solution
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $solution;
    /**
     * The completeInfoProduct
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CompleteInfoProduct
     */
    public $completeInfoProduct;
    /**
     * The serviceList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt_1
     */
    public $serviceList;
    /**
     * The multiServiceList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt_1
     */
    public $multiServiceList;
    /**
     * The completeOfferSortByThematic
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CompleteOfferSortByThematic
     */
    public $completeOfferSortByThematic;
    /**
     * Constructor method for ResultInfo
     * @uses ResultInfo::setAllSummary()
     * @uses ResultInfo::setInfoCountry()
     * @uses ResultInfo::setInfoAdministrativeZone1()
     * @uses ResultInfo::setInfoStars()
     * @uses ResultInfo::setInfoServices()
     * @uses ResultInfo::setInfoSubTypeProduct()
     * @uses ResultInfo::setArgumentForKml()
     * @uses ResultInfo::setSolution()
     * @uses ResultInfo::setCompleteInfoProduct()
     * @uses ResultInfo::setServiceList()
     * @uses ResultInfo::setMultiServiceList()
     * @uses ResultInfo::setCompleteOfferSortByThematic()
     * @param bool $allSummary
     * @param bool $infoCountry
     * @param bool $infoAdministrativeZone1
     * @param bool $infoStars
     * @param bool $infoServices
     * @param bool $infoSubTypeProduct
     * @param bool $argumentForKml
     * @param bool $solution
     * @param \StructType\CompleteInfoProduct $completeInfoProduct
     * @param \ArrayType\ArrayOfInt_1 $serviceList
     * @param \ArrayType\ArrayOfInt_1 $multiServiceList
     * @param \StructType\CompleteOfferSortByThematic $completeOfferSortByThematic
     */
    public function __construct($allSummary = null, $infoCountry = null, $infoAdministrativeZone1 = null, $infoStars = null, $infoServices = null, $infoSubTypeProduct = null, $argumentForKml = null, $solution = null, \StructType\CompleteInfoProduct $completeInfoProduct = null, \ArrayType\ArrayOfInt_1 $serviceList = null, \ArrayType\ArrayOfInt_1 $multiServiceList = null, \StructType\CompleteOfferSortByThematic $completeOfferSortByThematic = null)
    {
        $this
            ->setAllSummary($allSummary)
            ->setInfoCountry($infoCountry)
            ->setInfoAdministrativeZone1($infoAdministrativeZone1)
            ->setInfoStars($infoStars)
            ->setInfoServices($infoServices)
            ->setInfoSubTypeProduct($infoSubTypeProduct)
            ->setArgumentForKml($argumentForKml)
            ->setSolution($solution)
            ->setCompleteInfoProduct($completeInfoProduct)
            ->setServiceList($serviceList)
            ->setMultiServiceList($multiServiceList)
            ->setCompleteOfferSortByThematic($completeOfferSortByThematic);
    }
    /**
     * Get allSummary value
     * @return bool
     */
    public function getAllSummary()
    {
        return $this->allSummary;
    }
    /**
     * Set allSummary value
     * @param bool $allSummary
     * @return \StructType\ResultInfo
     */
    public function setAllSummary($allSummary = null)
    {
        // validation for constraint: boolean
        if (!is_null($allSummary) && !is_bool($allSummary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($allSummary, true), gettype($allSummary)), __LINE__);
        }
        $this->allSummary = $allSummary;
        return $this;
    }
    /**
     * Get infoCountry value
     * @return bool
     */
    public function getInfoCountry()
    {
        return $this->infoCountry;
    }
    /**
     * Set infoCountry value
     * @param bool $infoCountry
     * @return \StructType\ResultInfo
     */
    public function setInfoCountry($infoCountry = null)
    {
        // validation for constraint: boolean
        if (!is_null($infoCountry) && !is_bool($infoCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($infoCountry, true), gettype($infoCountry)), __LINE__);
        }
        $this->infoCountry = $infoCountry;
        return $this;
    }
    /**
     * Get infoAdministrativeZone1 value
     * @return bool
     */
    public function getInfoAdministrativeZone1()
    {
        return $this->infoAdministrativeZone1;
    }
    /**
     * Set infoAdministrativeZone1 value
     * @param bool $infoAdministrativeZone1
     * @return \StructType\ResultInfo
     */
    public function setInfoAdministrativeZone1($infoAdministrativeZone1 = null)
    {
        // validation for constraint: boolean
        if (!is_null($infoAdministrativeZone1) && !is_bool($infoAdministrativeZone1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($infoAdministrativeZone1, true), gettype($infoAdministrativeZone1)), __LINE__);
        }
        $this->infoAdministrativeZone1 = $infoAdministrativeZone1;
        return $this;
    }
    /**
     * Get infoStars value
     * @return bool
     */
    public function getInfoStars()
    {
        return $this->infoStars;
    }
    /**
     * Set infoStars value
     * @param bool $infoStars
     * @return \StructType\ResultInfo
     */
    public function setInfoStars($infoStars = null)
    {
        // validation for constraint: boolean
        if (!is_null($infoStars) && !is_bool($infoStars)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($infoStars, true), gettype($infoStars)), __LINE__);
        }
        $this->infoStars = $infoStars;
        return $this;
    }
    /**
     * Get infoServices value
     * @return bool
     */
    public function getInfoServices()
    {
        return $this->infoServices;
    }
    /**
     * Set infoServices value
     * @param bool $infoServices
     * @return \StructType\ResultInfo
     */
    public function setInfoServices($infoServices = null)
    {
        // validation for constraint: boolean
        if (!is_null($infoServices) && !is_bool($infoServices)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($infoServices, true), gettype($infoServices)), __LINE__);
        }
        $this->infoServices = $infoServices;
        return $this;
    }
    /**
     * Get infoSubTypeProduct value
     * @return bool
     */
    public function getInfoSubTypeProduct()
    {
        return $this->infoSubTypeProduct;
    }
    /**
     * Set infoSubTypeProduct value
     * @param bool $infoSubTypeProduct
     * @return \StructType\ResultInfo
     */
    public function setInfoSubTypeProduct($infoSubTypeProduct = null)
    {
        // validation for constraint: boolean
        if (!is_null($infoSubTypeProduct) && !is_bool($infoSubTypeProduct)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($infoSubTypeProduct, true), gettype($infoSubTypeProduct)), __LINE__);
        }
        $this->infoSubTypeProduct = $infoSubTypeProduct;
        return $this;
    }
    /**
     * Get argumentForKml value
     * @return bool
     */
    public function getArgumentForKml()
    {
        return $this->argumentForKml;
    }
    /**
     * Set argumentForKml value
     * @param bool $argumentForKml
     * @return \StructType\ResultInfo
     */
    public function setArgumentForKml($argumentForKml = null)
    {
        // validation for constraint: boolean
        if (!is_null($argumentForKml) && !is_bool($argumentForKml)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($argumentForKml, true), gettype($argumentForKml)), __LINE__);
        }
        $this->argumentForKml = $argumentForKml;
        return $this;
    }
    /**
     * Get solution value
     * @return bool
     */
    public function getSolution()
    {
        return $this->solution;
    }
    /**
     * Set solution value
     * @param bool $solution
     * @return \StructType\ResultInfo
     */
    public function setSolution($solution = null)
    {
        // validation for constraint: boolean
        if (!is_null($solution) && !is_bool($solution)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($solution, true), gettype($solution)), __LINE__);
        }
        $this->solution = $solution;
        return $this;
    }
    /**
     * Get completeInfoProduct value
     * @return \StructType\CompleteInfoProduct|null
     */
    public function getCompleteInfoProduct()
    {
        return $this->completeInfoProduct;
    }
    /**
     * Set completeInfoProduct value
     * @param \StructType\CompleteInfoProduct $completeInfoProduct
     * @return \StructType\ResultInfo
     */
    public function setCompleteInfoProduct(\StructType\CompleteInfoProduct $completeInfoProduct = null)
    {
        $this->completeInfoProduct = $completeInfoProduct;
        return $this;
    }
    /**
     * Get serviceList value
     * @return \ArrayType\ArrayOfInt_1|null
     */
    public function getServiceList()
    {
        return $this->serviceList;
    }
    /**
     * Set serviceList value
     * @param \ArrayType\ArrayOfInt_1 $serviceList
     * @return \StructType\ResultInfo
     */
    public function setServiceList(\ArrayType\ArrayOfInt_1 $serviceList = null)
    {
        $this->serviceList = $serviceList;
        return $this;
    }
    /**
     * Get multiServiceList value
     * @return \ArrayType\ArrayOfInt_1|null
     */
    public function getMultiServiceList()
    {
        return $this->multiServiceList;
    }
    /**
     * Set multiServiceList value
     * @param \ArrayType\ArrayOfInt_1 $multiServiceList
     * @return \StructType\ResultInfo
     */
    public function setMultiServiceList(\ArrayType\ArrayOfInt_1 $multiServiceList = null)
    {
        $this->multiServiceList = $multiServiceList;
        return $this;
    }
    /**
     * Get completeOfferSortByThematic value
     * @return \StructType\CompleteOfferSortByThematic|null
     */
    public function getCompleteOfferSortByThematic()
    {
        return $this->completeOfferSortByThematic;
    }
    /**
     * Set completeOfferSortByThematic value
     * @param \StructType\CompleteOfferSortByThematic $completeOfferSortByThematic
     * @return \StructType\ResultInfo
     */
    public function setCompleteOfferSortByThematic(\StructType\CompleteOfferSortByThematic $completeOfferSortByThematic = null)
    {
        $this->completeOfferSortByThematic = $completeOfferSortByThematic;
        return $this;
    }
}
